import { PubSubEngine } from 'graphql-subscriptions';
import { PubSubAMQPConfig } from './amqp/interfaces';
export declare class AMQPPubSub implements PubSubEngine {
    private publisher;
    private subscriber;
    private exchange;
    private subscriptionMap;
    private subsRefsMap;
    private unsubscribeMap;
    private currentSubscriptionId;
    constructor(config: PubSubAMQPConfig);
    publish(routingKey: string, payload: any): Promise<void>;
    subscribe(routingKey: string | 'fanout', onMessage: (message: any) => void): Promise<number>;
    unsubscribe(subId: number): Promise<void>;
    asyncIterator<T>(triggers: string | string[]): AsyncIterator<T>;
    private onMessage;
    private unsubscribeForKey;
}
